【Codeforces 1019A】Elections

【链接】 我是链接,点我呀:)
【题意】

每个人都有自己喜欢的队员
但是如果贿赂他们可以让他们更改自己喜欢的队员
问你最少要花多少钱贿赂队员才能让1号队员严格有最多的人喜欢?

【题解】

除了1号之外,其他队员最后喜欢的人数不太好确定。
我们可以这样,用up枚举其他人最后喜欢的人数的上限(即除了1之外所有人都不能超过up)
如果某个人的被喜欢人数超过了,则把所有喜欢这个人当中需要贿赂用的钱数最低的几个贿赂了.让他低于up
然后我们再在这种情况下,让1号队员成为最被喜欢的人(选择之前没被贿赂的且原本不是选择1的人贿赂它,直到1号队员被喜欢人数大于所有人
这样就能覆盖所有的情况了。
取所有情况下的最小值即可。

【代码】

import java.io.*;
import java.util.*;

public class Main {

    static InputReader in;
    static PrintWriter out;

    public static void main(String[] args) throws IOException{
        //InputStream ins = new FileInputStream("E:\\rush.txt");
        InputStream ins = System.in;
        in = new InputReader(ins);
        out = new PrintWriter(System.out);
        //code start from here
        new Task().solve(in, out);
        out.close();
    }

    static int N = 3000;
    static class Task{

        int n,m,id;
        int p[],c[];

        static class Person implements Comparable<Person>{
            int prefer,cost,id;
            Person(int prefer,int cost,int id) {
                this.prefer = prefer;
                this.cost = cost;
                this.id = id;
            }
            @Override
            public int compareTo(Person o) {
                // TODO Auto-generated method stub
                return this.cost-o.cost;
            }

        }
        Person persons[];
        ArrayList voters[];
        boolean flag[];

        public void solve(InputReader in,PrintWriter out) {
            flag = new boolean[N+10];
            persons = new Person[N+10];
            voters = new ArrayList[N+10];
            p = new int[N+10];c = new int[N+10];
            n = in.nextInt();m = in.nextInt();
            for (int i = 1;i <= n;i++) {
                int pp,cc;
                pp = in.nextInt();cc = in.nextInt();
                p[i] = pp;c[i] = cc;
                persons[i] = new Person(pp,cc,i);
            }
            Arrays.sort(persons, 1,n+1);
            for (int i = 1;i <= m;i++) voters[i] = new ArrayList();
            for (int i = 1;i <= n;i++) {
                voters[persons[i].prefer].add(persons[i].id);
            }
            long ans = -1;
            for (int up = 1;up <= n;up++) {
                for (int j = 1;j <= n;j++) flag[j] = false;
                long temp = 0;
                int cnt = voters[1].size(),ma = 0;
                for (int j = 2;j <= m;j++) {
                    int len = voters[j].size();
                    //out.println("voters["+j+"].size="+len);
                    if (len>=up) {
                        for (int k = 0;k <= len-up;k++) {
                            flag[(int)voters[j].get(k)] = true;
                            temp = temp + c[(int)voters[j].get(k)];
                            cnt++;
                        }
                        ma = Math.max(ma, up-1);
                    }else {
                        ma = Math.max(ma, len);
                    }
                }
                if (cnt<=ma)
                    for (int j = 1;j <= n;j++)
                        if (flag[persons[j].id]==false && persons[j].prefer!=1) {
                            if (cnt<=ma) {
                                cnt++;
                                flag[persons[j].id] = true;
                                temp = temp + persons[j].cost;
                            }else break;
                        }
                if (cnt>ma) {
                    if (ans==-1) {
                        ans = temp;
                    }else {
                        ans = Math.min(ans, temp);
                    }
                }
            }
            out.println(ans);
        }
    }

    static class InputReader{
        public BufferedReader br;
        public StringTokenizer tokenizer;

        public InputReader(InputStream ins) {
            br = new BufferedReader(new InputStreamReader(ins));
            tokenizer = null;
        }

        public String next(){
            while (tokenizer==null || !tokenizer.hasMoreTokens()) {
                try {
                tokenizer = new StringTokenizer(br.readLine());
                }catch(IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }
    }
}

原文地址:https://www.cnblogs.com/AWCXV/p/10440066.html

时间: 2024-10-06 22:55:44

【Codeforces 1019A】Elections的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

【codeforces 415D】Mashmokh and ACM(普通dp)

[codeforces 415D]Mashmokh and ACM 题意:美丽数列定义:对于数列中的每一个i都满足:arr[i+1]%arr[i]==0 输入n,k(1<=n,k<=2000),问满足[数列长度是k && 数列中每一个元素arr[i]在1~n之间 && 数列中元素可以重复]的数列有多少个?结果对10^9+7取余 解题思路:dp[i][j]表示长度是j,最后一位是i的种数 if(kk%i==0) dp[kk][j+1]+=dp[i][j] 1 #i

【Codeforces 368A】Brain&#39;s Photos 水题

黑白灰都是#Black&White #include <cstdio> int n,m; int main() { scanf("%d%d",&n,&m); int ok=0; for(int i=0;i<n;i++) for(int j=0;j<m;j++) { char s[5]; scanf("%s",s); if(s[0]!='W'&&s[0]!='B'&&s[0]!='G')

【Codeforces 1114C】Trailing Loves (or L&#39;oeufs?)

[链接] 我是链接,点我呀:) [题意] 问你n!的b进制下末尾的0的个数 [题解] 证明:https://blog.csdn.net/qq_40679299/article/details/81167283 这题的话m比较大, 做个质因数分解就ok>_< 算n!有多少个x因子的话 以5为例子 (n=25) 25 20 15 10 5 把他们都除5 5 4 3 2 1 然后再除5 1 所以总共有6个 转换成代码就是 while(n>0){ ans+=n/5; n = n/5; } [代码

【Codeforces 332C】Students&#39; Revenge

Codeforces 332 C 我爱对拍,对拍使我快乐... 题意:有\(n\)个议题,学生们会让议会同意\(p\)个,其中主席会执行\(k\)个, 每一个议题执行后主席会掉\(a_i\)的头发,不执行后议会会增加\(b_i\)的不开心值, 然后主席想让议会的不开心值最小,如果有多重方案就选自己头发掉的最少的: 而学生们想让主席的头发掉的最多,如果有多种方案让议会的不开心值最大. 问让议会同意哪\(p\)个会达到最好的效果. 思路1: 这是我的不对的思路. (虽然没提交 我们首先将所有的数按照

【Codeforces 429D】 Tricky Function

[题目链接] http://codeforces.com/problemset/problem/429/D [算法] 令Si = A1 + A2 + ... + Ai(A的前缀和) 则g(i,j) = Sj - Si f(i,j) = (i-j)^2 + (Si - Sj)^2 观察这个式子,我们发现可以用类似于平面最近点对的算法来求解该问题 [代码] #include<bits/stdc++.h> using namespace std; #define MAXN 100010 const

【Codeforces 105D】 Bag of mice

[题目链接] http://codeforces.com/contest/148/problem/D [算法] 概率DP f[w][b]表示还剩w只白老鼠,b只黑老鼠,公主胜利的概率,那么 : 1. 公主抓到白老鼠,概率为w/(w+b) 2. 公主抓到黑老鼠,那么龙也抓到黑老鼠,如果跑出来的老鼠是白颜色的,则概率为 : b / (w + b) * b / (w + b - 1) * w / (w + b - 2) * f[w-1][b-2] 否则,概率为 : b / (w + b) * (b -

【Codeforces 258A】 Game With Sticks

[题目链接] http://codeforces.com/contest/451/problem/A [算法] 若n和m中的最小值是奇数,则先手胜,否则后手胜 [代码] #include<bits/stdc++.h> using namespace std; int n,m; int main() { scanf("%d%d",&n,&m); if (min(n,m) % 2 == 0) printf("Malvika\n"); else

【Codeforces 258B】 Sort the Array

[题目链接] http://codeforces.com/contest/451/problem/B [算法] 模拟 在序列中找到一段单调递增的子序列,将这段序列反转,然后判断序列是否变得单调递增,即可 [代码] #include<bits/stdc++.h> using namespace std; const int MAXN = 1e5 + 10; int i,n,l,r; bool flag; int a[MAXN]; int main() { scanf("%d"